mtl-1.1.1.0: Monad transformer library

Portability | non-portable (multi-param classes, functional dependencies)
Stability | experimental
Maintainer | libraries@haskell.org

Control.Monad.State.Class

Contents

- MonadState class

Description

MonadState class.

This module is inspired by the paper /Functional Programming with Overloading and Higher-Order Polymorphism/, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

Synopsis

- class Monad m => MonadState s m | m -> s where
  - get :: m s
  - put :: s -> m ()
- modify :: MonadState s m => (s -> s) -> m ()
- gets :: MonadState s m => (s -> a) -> m a

# MonadState class

class Monad m => MonadState s m | m -> s where

get returns the state from the internals of the monad.

put replaces the state inside the monad.

Methods

get :: m s

put :: s -> m ()

Instances

MonadState s m => MonadState s (ListT m) |
MonadState s (State s) |
MonadState s (State s) |
MonadState s m => MonadState s (ReaderT r m) |
(Error e, MonadState s m) => MonadState s (ErrorT e m) |
Monad m => MonadState s (StateT s m) |
Monad m => MonadState s (StateT s m) |
(Monoid w, MonadState s m) => MonadState s (WriterT w m) |
(Monoid w, MonadState s m) => MonadState s (WriterT w m) |
MonadState s m => MonadState s (ContT r m) |
Monoid w => MonadState s (RWS r w s) |
Monoid w => MonadState s (RWS r w s) |
(Monoid w, Monad m) => MonadState s (RWST r w s m) |
(Monoid w, Monad m) => MonadState s (RWST r w s m) |

modify :: MonadState s m => (s -> s) -> m ()

Monadic state transformer.

Maps an old state to a new state inside a state monad. The old state is thrown away.

          Main> :t modify ((+1) :: Int -> Int)
          modify (...) :: (MonadState Int a) => a ()

This says that `modify (+1)` acts over any Monad that is a member of the `MonadState` class, with an `Int` state.

gets :: MonadState s m => (s -> a) -> m a

Gets specific component of the state, using a projection function supplied.